﻿using Abp.Json;
using BCS.BMC.Controllers;
using BCS.BMC.FirebaseCloudMessaging;
using BCS.BMC.FirebaseCloudMessaging.Dto;
using BCS.BMC.Models.TokenAuth;
using FirebaseAdmin.Messaging;
using Microsoft.AspNetCore.Mvc;
using Newtonsoft.Json;
using System.Collections.Generic;
using System.Threading.Tasks;

namespace BCS.BMC.Web.Controllers
{

    [Route("api/[controller]/[action]")]
    public class NotificationController : BMCControllerBase
    {
        private readonly IFirebaseNotificationAppService _notificationService;

        public NotificationController(IFirebaseNotificationAppService notificationService)
        {
            _notificationService = notificationService;
        }


        [HttpPost]
        public async Task<IActionResult> SendNotification([FromBody] FireBaseResponseModel notification)
        {
            var result = await _notificationService.SendNotification(notification);         
            return Ok(result.Responses);
        }

        [HttpPost]
        public async Task<IActionResult> GetNotifications(NotificationModel notification)
        {
            var result =  _notificationService.GetNotification(notification);
            return Ok();
        }
    }
}
